# SPDX-FileCopyrightText: 2024 Maurice Debray <maurice.debray@dgnum.eu>
#
# SPDX-License-Identifier: EUPL-1.2

{
  fetchgit,
  rustPlatform,
  protobuf,
  runCommand,
}:
let
  tvix-hash = "sha256-I4GJD1nbZ9gdYhXWOKBkqUvTdCxEoQe+Y5ZOYVRWi2w=";
  tvix-src = fetchgit {
    name = "tvix";
    url = "https://git.dgnum.eu/mdebray/tvl-depot";
    rev = "5d3769594ed6eb57dbb06dfb947a8429bdcca4f6";
    hash = tvix-hash;
  };
  protos = runCommand "tvix-protos" { } ''
    mkdir $out
    cd ${tvix-src}/tvix #remove tvix maybe
    find . -name '*.proto' -exec install -D {} $out/{} \;
  '';
in

rustPlatform.buildRustPackage {
  pname = "multitenant-binary-cache";
  version = "0.1.0";

  src = fetchgit {
    url = "https://git.lix.systems/sinavir/multitenant-tvix-binary-cache.git";
    rev = "5f5a54d3d3c1c349b5d67f58b8392467705dbc06";
    hash = "sha256-FZuvkHKvnFuFu50bC7wMRtEJv9wpo5OfXV0u4eQKrvw=";
  };

  PROTO_ROOT = protos;

  nativeBuildInputs = [ protobuf ];

  cargoLock = {
    lockFile = ./Cargo.lock;
    outputHashes = {
      "wu-manber-0.1.0" = "sha256-7YIttaQLfFC/32utojh2DyOHVsZiw8ul/z0lvOhAE/4=";
      "nar-bridge-0.1.0" = tvix-hash;
    };
  };
  cargoHash = "";

  meta = { };
}
