# SPDX-FileCopyrightText: 2024 Tom Hubrecht <tom.hubrecht@dgnum.eu>
#
# SPDX-License-Identifier: EUPL-1.2

{
  lib,
  buildPythonPackage,
  poetry-core,
  aiohttp,
  authlib,
  kanidm,
  pydantic,
  toml,
}:

buildPythonPackage {
  inherit (kanidm) pname version src;
  pyproject = true;

  patches = [
    ./02-remove-noisy-logs.patch
  ];

  sourceRoot = "source/pykanidm";

  build-system = [ poetry-core ];

  dependencies = [
    aiohttp
    authlib
    pydantic
    toml
  ];

  pythonImportsCheck = [ "kanidm" ];

  meta = with lib; {
    description = "Kanidm: A simple, secure and fast identity management platform";
    homepage = "https://github.com/kanidm/kanidm";
    license = licenses.mpl20;
    maintainers = with maintainers; [ thubrecht ];
  };
}
